# ]po[ Slack Integration
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Slack Integration:

<img align="right" alt="hive_module_pm_single" src="https://www.project-open.com/images/hive_module_pm_single.gif" /><p>This <a href="https://www.slack.com">Slack<span class="external"> </span></a> integration package automatically generates a Slack channel for each ]project-open[ project, invites project members to this channel, stores channel communication in a searchable format, sends out project notifications and provides a number of slash-commands to simplify hour logging, status updates etc. <p>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=1800549&amp;path=packages/intranet-slack/tcl/intranet-slack-procs.tcl">tcl/intranet-slack-procs.tcl</a></b></td><td></td><td></td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_package_slack_id">im_package_slack_id</a></b></td><td></td><td>Returns the package id of the intranet-slack module </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_action">im_slack_action</a></b></td><td></td><td>Main entry into Slack integration. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_arg_parser">im_slack_arg_parser</a></b></td><td></td><td>Main parser. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_arg_parser_arg_type">im_slack_arg_parser_arg_type</a></b></td><td></td><td>Tries to extract an argument of type=type from line at the given pos. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_arg_parser_one_arg">im_slack_arg_parser_one_arg</a></b></td><td></td><td>Tries to extract an argument from an input line. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_available_commands_json">im_slack_available_commands_json</a></b></td><td></td><td>Create a JSON list with the list of available commands, suitable to be used as &quot;attachment&quot; in a Slack reply </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_commands">im_slack_commands</a></b></td><td></td><td>Returns a data-structure with the list of available commands, plus there meta-data. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_log_hours">im_slack_log_hours</a></b></td><td></td><td>Logs hours for the current user on the current project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=1800549&amp;proc=im_slack_test">im_slack_test</a></b></td><td></td><td>Checks some standard test cases </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=1800549&amp;path=packages/intranet-slack/www/next-object-id.adp">next-object-id.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=1800549&amp;path=packages/intranet-slack/www/po.tcl">po.tcl</a></b></td><td>Slack integration page</td></tr></table>

