ad_page_contract {
    Slack integration page
} {
    { channel_id "" }
    { channel_name "" }
    { command "" }
    { response_url "" }
    { team_domain "" }
    { team_id "" }
    { text "" }
    { token "" }
    { user_id "" }
    { user_name "" }
}

set header_vars [ns_conn headers]
set url [ns_conn url]
set current_user_id [ad_conn user_id]
set current_user_name [db_string uname "select im_name_from_user_id(:current_user_id)" -default "unknown"]
set client_ip [ns_set get $header_vars "Client-ip"]
set referer_url [ns_set get $header_vars "Referer"]
set peer_ip [ns_conn peeraddr]
set current_url [im_url_with_query]

array set vars {}
set vars(channel_id) $channel_id
set vars(channel_name) $channel_name
set vars(command) $command
set vars(response_url) $response_url
set vars(team_domain) $team_domain
set vars(team_id) $team_id
set vars(text) $text
set vars(token) $token
set vars(user_id) $user_id
set vars(user_name) $user_name
set vars(current_url) $current_url
set vars(peer_ip) $peer_ip
set vars(user_id) $user_id


foreach var [ad_ns_set_keys $header_vars] {
    set value [ns_set get $header_vars $var]
    # set vars($var) $value
}



# Ignore the generic /po command, but keep other commands
# as the first word in the line.
# So "/po log 10 hours" is equivalent to "/log 10 hours".
if {"/po" eq $command} {
    set line $text
} else {
    set line "[string range $command 1 end] $text"
}

# Start the actual action
ns_log Notice "im_slack: vars=[array get vars]"
set result [im_slack_action -line $line -var_list [array get vars]]
ns_log Notice "im_slack: result=$result"

if {[string range "{}" 0 0] eq [string range $result 0 0]} {
    ns_log Notice "im_slack: Found a JSON string return value - returning directly"
    ns_return 200 "application/json" $result
} else {
    ns_log Notice "im_slack: Found a text string return value - packaging as JSON"

    # set attachments [list]
    set response_type "in_channel"; # Response visible to all channel members
    set response_type "ephemeral"; # Only visible to the user who issued the command
    
    ns_return 200 "application/json" "{\n\"response_type\": \"$response_type\",\n\"text\": \"$result\"\n}"
}

